/*
Copyright (c) 2018 Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

enum
{ 
   GFX_K_PRT=1, 
   GFX_K_BACKSPACE,     GFX_K_TAB,      GFX_K_RETURN, GFX_K_ESCAPE,
   GFX_K_INSERT,        GFX_K_DELETE,   GFX_K_HOME,   GFX_K_END,
   GFX_K_PAGEUP,        GFX_K_PAGEDOWN,
   GFX_K_LEFT,          GFX_K_RIGHT,    GFX_K_DOWN,   GFX_K_UP,
   GFX_K_F1,            GFX_K_F2,       GFX_K_F3,     GFX_K_F4, 
   GFX_K_F5,            GFX_K_F6,       GFX_K_F7,     GFX_K_F8, 
   GFX_K_F9,            GFX_K_F10,      GFX_K_F11,    GFX_K_F12, 
   GFX_K_CONTROL=0x100, GFX_K_SHIFT= 0x200 , GFX_K_ALT= 0x400,
};

int  gfx_init(char *name);
int  gfx_start(int width, int height, char *title);
void gfx_update(int x,int y,int width,int height);
void gfx_close();
void gfx_update_all();
void gfx_event();
void gfx_dpi(int *Xdpi,int *Ydpi);
int gfx_buffer(uint32_t ***Buffer, unsigned int *W, unsigned int *H);
int gfx_descriptor();
void gfx_flush();

void key_event(int key, unsigned int wide, char *str);
void mouse_event(int event, int button, int x, int y);
void quit_request();
void selection_lost();

void gfx_set_window_title(uint8_t *title);
void gfx_pointer_move_events(int report);


char *gfx_get_selection(int sel);

/** 
  When the user selects some text, you call gfx_set_selection().
  This copies the text into the PRIMARY selection. When the user
  gives the command "Copy", the selection is moved into the 
  CLIPBOARD selection using gfx_copy_selection(). At this point,
  the PRIMARY selection is lost. Now the user can once again use
  the PRIMARY selection. **/
void gfx_set_selection(char *data);
void gfx_copy_selection();

void gfx_unset_selection();

